/*
 * vbase.cpp
 *
 *  Created on: Mar 9, 2011
 *      Author: lipari
 */

#include <iostream>
using namespace std;

class Top {
protected:
    int x;
public:
    Top() : x(0) {}
    Top(int n) { x = n; }
    virtual ~Top() {}

    int getX() { return x; }
};

class Left : virtual public Top {
protected:
  int y;
public:
  Left(int m, int n) : Top(m) { y = n; }
};

class Right : virtual public Top {
protected:
  int z;
public:
  Right(int m, int n) : Top(m) { z = n; }
};

//
class Bottom : public Left, public Right {
  int w;
public:
  Bottom(int i, int j, int k, int m)
  : Top(i), Left(25, k), Right(25, m) { w = m; }
};

int main() {
    Bottom b(1, 2, 3, 4);

    cout << sizeof(b) << endl;
    cout << b.getX() << endl;

    //cout << b << endl;
//  cout << static_cast<void*>(&b) << endl;
//  Top* p = static_cast<Top*>(&b);
//  cout << *p << endl;
//  cout << static_cast<void*>(p) << endl;
//  cout << dynamic_cast<void*>(p) << endl;
}
